---
name: "CodeQL"

on:
  pull_request:
    branches:
      - master
  push:
    branches:
      - master

permissions:
  contents: read

env:
  CC: "gcc"
  BUILD_ONLY: "true"

jobs:
  analyze:
    name: Analyze
    runs-on: ubuntu-22.04
    concurrency:
      group: ${{ github.workflow }}-${{ matrix.language }}-${{ github.ref }}
      cancel-in-progress: true
    permissions:
      actions: read
      security-events: write

    strategy:
      fail-fast: false
      matrix:
        language: ['cpp', 'python', 'csharp']

    steps:
    - name: Checkout repository
      uses: actions/checkout@v4

    - name: Initialize CodeQL
      uses: github/codeql-action/init@v2
      with:
        languages: ${{ matrix.language }}

    - run: sudo -E .github/workflows/build.sh install-build-deps

    - run: .github/workflows/build.sh build

    - name: Perform CodeQL Analysis
      uses: github/codeql-action/analyze@v2
